/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha1 "knative.dev/eventing/pkg/apis/eventing/v1alpha1"
)

// FakeRequestReplies implements RequestReplyInterface
type FakeRequestReplies struct {
	Fake *FakeEventingV1alpha1
	ns   string
}

var requestrepliesResource = v1alpha1.SchemeGroupVersion.WithResource("requestreplies")

var requestrepliesKind = v1alpha1.SchemeGroupVersion.WithKind("RequestReply")

// Get takes name of the requestReply, and returns the corresponding requestReply object, and an error if there is any.
func (c *FakeRequestReplies) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.RequestReply, err error) {
	emptyResult := &v1alpha1.RequestReply{}
	obj, err := c.Fake.
		Invokes(testing.NewGetActionWithOptions(requestrepliesResource, c.ns, name, options), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1alpha1.RequestReply), err
}

// List takes label and field selectors, and returns the list of RequestReplies that match those selectors.
func (c *FakeRequestReplies) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.RequestReplyList, err error) {
	emptyResult := &v1alpha1.RequestReplyList{}
	obj, err := c.Fake.
		Invokes(testing.NewListActionWithOptions(requestrepliesResource, requestrepliesKind, c.ns, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.RequestReplyList{ListMeta: obj.(*v1alpha1.RequestReplyList).ListMeta}
	for _, item := range obj.(*v1alpha1.RequestReplyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested requestReplies.
func (c *FakeRequestReplies) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchActionWithOptions(requestrepliesResource, c.ns, opts))

}

// Create takes the representation of a requestReply and creates it.  Returns the server's representation of the requestReply, and an error, if there is any.
func (c *FakeRequestReplies) Create(ctx context.Context, requestReply *v1alpha1.RequestReply, opts v1.CreateOptions) (result *v1alpha1.RequestReply, err error) {
	emptyResult := &v1alpha1.RequestReply{}
	obj, err := c.Fake.
		Invokes(testing.NewCreateActionWithOptions(requestrepliesResource, c.ns, requestReply, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1alpha1.RequestReply), err
}

// Update takes the representation of a requestReply and updates it. Returns the server's representation of the requestReply, and an error, if there is any.
func (c *FakeRequestReplies) Update(ctx context.Context, requestReply *v1alpha1.RequestReply, opts v1.UpdateOptions) (result *v1alpha1.RequestReply, err error) {
	emptyResult := &v1alpha1.RequestReply{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateActionWithOptions(requestrepliesResource, c.ns, requestReply, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1alpha1.RequestReply), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRequestReplies) UpdateStatus(ctx context.Context, requestReply *v1alpha1.RequestReply, opts v1.UpdateOptions) (result *v1alpha1.RequestReply, err error) {
	emptyResult := &v1alpha1.RequestReply{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceActionWithOptions(requestrepliesResource, "status", c.ns, requestReply, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1alpha1.RequestReply), err
}

// Delete takes name of the requestReply and deletes it. Returns an error if one occurs.
func (c *FakeRequestReplies) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(requestrepliesResource, c.ns, name, opts), &v1alpha1.RequestReply{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRequestReplies) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionActionWithOptions(requestrepliesResource, c.ns, opts, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.RequestReplyList{})
	return err
}

// Patch applies the patch and returns the patched requestReply.
func (c *FakeRequestReplies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.RequestReply, err error) {
	emptyResult := &v1alpha1.RequestReply{}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceActionWithOptions(requestrepliesResource, c.ns, name, pt, data, opts, subresources...), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1alpha1.RequestReply), err
}
