/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1 "knative.dev/eventing/pkg/apis/flows/v1"
	scheme "knative.dev/eventing/pkg/client/clientset/versioned/scheme"
)

// ParallelsGetter has a method to return a ParallelInterface.
// A group's client should implement this interface.
type ParallelsGetter interface {
	Parallels(namespace string) ParallelInterface
}

// ParallelInterface has methods to work with Parallel resources.
type ParallelInterface interface {
	Create(ctx context.Context, parallel *v1.Parallel, opts metav1.CreateOptions) (*v1.Parallel, error)
	Update(ctx context.Context, parallel *v1.Parallel, opts metav1.UpdateOptions) (*v1.Parallel, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, parallel *v1.Parallel, opts metav1.UpdateOptions) (*v1.Parallel, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.Parallel, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.ParallelList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.Parallel, err error)
	ParallelExpansion
}

// parallels implements ParallelInterface
type parallels struct {
	*gentype.ClientWithList[*v1.Parallel, *v1.ParallelList]
}

// newParallels returns a Parallels
func newParallels(c *FlowsV1Client, namespace string) *parallels {
	return &parallels{
		gentype.NewClientWithList[*v1.Parallel, *v1.ParallelList](
			"parallels",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1.Parallel { return &v1.Parallel{} },
			func() *v1.ParallelList { return &v1.ParallelList{} }),
	}
}
