/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1alpha1 "knative.dev/eventing/pkg/apis/sinks/v1alpha1"
	scheme "knative.dev/eventing/pkg/client/clientset/versioned/scheme"
)

// IntegrationSinksGetter has a method to return a IntegrationSinkInterface.
// A group's client should implement this interface.
type IntegrationSinksGetter interface {
	IntegrationSinks(namespace string) IntegrationSinkInterface
}

// IntegrationSinkInterface has methods to work with IntegrationSink resources.
type IntegrationSinkInterface interface {
	Create(ctx context.Context, integrationSink *v1alpha1.IntegrationSink, opts v1.CreateOptions) (*v1alpha1.IntegrationSink, error)
	Update(ctx context.Context, integrationSink *v1alpha1.IntegrationSink, opts v1.UpdateOptions) (*v1alpha1.IntegrationSink, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, integrationSink *v1alpha1.IntegrationSink, opts v1.UpdateOptions) (*v1alpha1.IntegrationSink, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.IntegrationSink, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.IntegrationSinkList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.IntegrationSink, err error)
	IntegrationSinkExpansion
}

// integrationSinks implements IntegrationSinkInterface
type integrationSinks struct {
	*gentype.ClientWithList[*v1alpha1.IntegrationSink, *v1alpha1.IntegrationSinkList]
}

// newIntegrationSinks returns a IntegrationSinks
func newIntegrationSinks(c *SinksV1alpha1Client, namespace string) *integrationSinks {
	return &integrationSinks{
		gentype.NewClientWithList[*v1alpha1.IntegrationSink, *v1alpha1.IntegrationSinkList](
			"integrationsinks",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha1.IntegrationSink { return &v1alpha1.IntegrationSink{} },
			func() *v1alpha1.IntegrationSinkList { return &v1alpha1.IntegrationSinkList{} }),
	}
}
