/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1 "knative.dev/eventing/pkg/apis/sources/v1"
	scheme "knative.dev/eventing/pkg/client/clientset/versioned/scheme"
)

// ContainerSourcesGetter has a method to return a ContainerSourceInterface.
// A group's client should implement this interface.
type ContainerSourcesGetter interface {
	ContainerSources(namespace string) ContainerSourceInterface
}

// ContainerSourceInterface has methods to work with ContainerSource resources.
type ContainerSourceInterface interface {
	Create(ctx context.Context, containerSource *v1.ContainerSource, opts metav1.CreateOptions) (*v1.ContainerSource, error)
	Update(ctx context.Context, containerSource *v1.ContainerSource, opts metav1.UpdateOptions) (*v1.ContainerSource, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, containerSource *v1.ContainerSource, opts metav1.UpdateOptions) (*v1.ContainerSource, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.ContainerSource, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.ContainerSourceList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.ContainerSource, err error)
	ContainerSourceExpansion
}

// containerSources implements ContainerSourceInterface
type containerSources struct {
	*gentype.ClientWithList[*v1.ContainerSource, *v1.ContainerSourceList]
}

// newContainerSources returns a ContainerSources
func newContainerSources(c *SourcesV1Client, namespace string) *containerSources {
	return &containerSources{
		gentype.NewClientWithList[*v1.ContainerSource, *v1.ContainerSourceList](
			"containersources",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1.ContainerSource { return &v1.ContainerSource{} },
			func() *v1.ContainerSourceList { return &v1.ContainerSourceList{} }),
	}
}
