/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1 "knative.dev/eventing/pkg/apis/sources/v1"
)

// FakePingSources implements PingSourceInterface
type FakePingSources struct {
	Fake *FakeSourcesV1
	ns   string
}

var pingsourcesResource = v1.SchemeGroupVersion.WithResource("pingsources")

var pingsourcesKind = v1.SchemeGroupVersion.WithKind("PingSource")

// Get takes name of the pingSource, and returns the corresponding pingSource object, and an error if there is any.
func (c *FakePingSources) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.PingSource, err error) {
	emptyResult := &v1.PingSource{}
	obj, err := c.Fake.
		Invokes(testing.NewGetActionWithOptions(pingsourcesResource, c.ns, name, options), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1.PingSource), err
}

// List takes label and field selectors, and returns the list of PingSources that match those selectors.
func (c *FakePingSources) List(ctx context.Context, opts metav1.ListOptions) (result *v1.PingSourceList, err error) {
	emptyResult := &v1.PingSourceList{}
	obj, err := c.Fake.
		Invokes(testing.NewListActionWithOptions(pingsourcesResource, pingsourcesKind, c.ns, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1.PingSourceList{ListMeta: obj.(*v1.PingSourceList).ListMeta}
	for _, item := range obj.(*v1.PingSourceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested pingSources.
func (c *FakePingSources) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchActionWithOptions(pingsourcesResource, c.ns, opts))

}

// Create takes the representation of a pingSource and creates it.  Returns the server's representation of the pingSource, and an error, if there is any.
func (c *FakePingSources) Create(ctx context.Context, pingSource *v1.PingSource, opts metav1.CreateOptions) (result *v1.PingSource, err error) {
	emptyResult := &v1.PingSource{}
	obj, err := c.Fake.
		Invokes(testing.NewCreateActionWithOptions(pingsourcesResource, c.ns, pingSource, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1.PingSource), err
}

// Update takes the representation of a pingSource and updates it. Returns the server's representation of the pingSource, and an error, if there is any.
func (c *FakePingSources) Update(ctx context.Context, pingSource *v1.PingSource, opts metav1.UpdateOptions) (result *v1.PingSource, err error) {
	emptyResult := &v1.PingSource{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateActionWithOptions(pingsourcesResource, c.ns, pingSource, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1.PingSource), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakePingSources) UpdateStatus(ctx context.Context, pingSource *v1.PingSource, opts metav1.UpdateOptions) (result *v1.PingSource, err error) {
	emptyResult := &v1.PingSource{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceActionWithOptions(pingsourcesResource, "status", c.ns, pingSource, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1.PingSource), err
}

// Delete takes name of the pingSource and deletes it. Returns an error if one occurs.
func (c *FakePingSources) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(pingsourcesResource, c.ns, name, opts), &v1.PingSource{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePingSources) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	action := testing.NewDeleteCollectionActionWithOptions(pingsourcesResource, c.ns, opts, listOpts)

	_, err := c.Fake.Invokes(action, &v1.PingSourceList{})
	return err
}

// Patch applies the patch and returns the patched pingSource.
func (c *FakePingSources) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.PingSource, err error) {
	emptyResult := &v1.PingSource{}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceActionWithOptions(pingsourcesResource, c.ns, name, pt, data, opts, subresources...), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1.PingSource), err
}
