/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "knative.dev/eventing/pkg/apis/eventing/v1alpha1"
)

// RequestReplyLister helps list RequestReplies.
// All objects returned here must be treated as read-only.
type RequestReplyLister interface {
	// List lists all RequestReplies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.RequestReply, err error)
	// RequestReplies returns an object that can list and get RequestReplies.
	RequestReplies(namespace string) RequestReplyNamespaceLister
	RequestReplyListerExpansion
}

// requestReplyLister implements the RequestReplyLister interface.
type requestReplyLister struct {
	listers.ResourceIndexer[*v1alpha1.RequestReply]
}

// NewRequestReplyLister returns a new RequestReplyLister.
func NewRequestReplyLister(indexer cache.Indexer) RequestReplyLister {
	return &requestReplyLister{listers.New[*v1alpha1.RequestReply](indexer, v1alpha1.Resource("requestreply"))}
}

// RequestReplies returns an object that can list and get RequestReplies.
func (s *requestReplyLister) RequestReplies(namespace string) RequestReplyNamespaceLister {
	return requestReplyNamespaceLister{listers.NewNamespaced[*v1alpha1.RequestReply](s.ResourceIndexer, namespace)}
}

// RequestReplyNamespaceLister helps list and get RequestReplies.
// All objects returned here must be treated as read-only.
type RequestReplyNamespaceLister interface {
	// List lists all RequestReplies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.RequestReply, err error)
	// Get retrieves the RequestReply from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.RequestReply, error)
	RequestReplyNamespaceListerExpansion
}

// requestReplyNamespaceLister implements the RequestReplyNamespaceLister
// interface.
type requestReplyNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha1.RequestReply]
}
