/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "knative.dev/eventing/pkg/apis/sinks/v1alpha1"
)

// JobSinkLister helps list JobSinks.
// All objects returned here must be treated as read-only.
type JobSinkLister interface {
	// List lists all JobSinks in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.JobSink, err error)
	// JobSinks returns an object that can list and get JobSinks.
	JobSinks(namespace string) JobSinkNamespaceLister
	JobSinkListerExpansion
}

// jobSinkLister implements the JobSinkLister interface.
type jobSinkLister struct {
	listers.ResourceIndexer[*v1alpha1.JobSink]
}

// NewJobSinkLister returns a new JobSinkLister.
func NewJobSinkLister(indexer cache.Indexer) JobSinkLister {
	return &jobSinkLister{listers.New[*v1alpha1.JobSink](indexer, v1alpha1.Resource("jobsink"))}
}

// JobSinks returns an object that can list and get JobSinks.
func (s *jobSinkLister) JobSinks(namespace string) JobSinkNamespaceLister {
	return jobSinkNamespaceLister{listers.NewNamespaced[*v1alpha1.JobSink](s.ResourceIndexer, namespace)}
}

// JobSinkNamespaceLister helps list and get JobSinks.
// All objects returned here must be treated as read-only.
type JobSinkNamespaceLister interface {
	// List lists all JobSinks in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.JobSink, err error)
	// Get retrieves the JobSink from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.JobSink, error)
	JobSinkNamespaceListerExpansion
}

// jobSinkNamespaceLister implements the JobSinkNamespaceLister
// interface.
type jobSinkNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha1.JobSink]
}
